/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFBinaryHeap;

import dstep.corefoundation.CFBase;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

struct __CFBinaryHeap;
alias __CFBinaryHeap* CFBinaryHeapRef;

extern (C)
{
	alias void function (void*, void*) CFBinaryHeapApplierFunction;
}

extern (C)
{
	extern
	{
		const CFBinaryHeapCallBacks kCFStringBinaryHeapCallBacks;
	}
}

struct CFBinaryHeapCompareContext
{
	int version_;
	void* info;
}


struct CFBinaryHeapCallBacks
{
	int version_;
	void* ptr2;
}

extern (C)
{
	uint CFBinaryHeapGetTypeID ();
	CFBinaryHeapRef CFBinaryHeapCreate (CFAllocatorRef allocator, int capacity, CFBinaryHeapCallBacks* callBacks, CFBinaryHeapCompareContext* compareContext);
	CFBinaryHeapRef CFBinaryHeapCreateCopy (CFAllocatorRef allocator, int capacity, CFBinaryHeapRef heap);
	int CFBinaryHeapGetCount (CFBinaryHeapRef heap);
	int CFBinaryHeapGetCountOfValue (CFBinaryHeapRef heap, void* value);
	ubyte CFBinaryHeapContainsValue (CFBinaryHeapRef heap, void* value);
	void* CFBinaryHeapGetMinimum (CFBinaryHeapRef heap);
	ubyte CFBinaryHeapGetMinimumIfPresent (CFBinaryHeapRef heap, void** value);
	void CFBinaryHeapGetValues (CFBinaryHeapRef heap, void** values);
	void CFBinaryHeapApplyFunction (CFBinaryHeapRef heap, CFBinaryHeapApplierFunction* applier, void* context);
	void CFBinaryHeapAddValue (CFBinaryHeapRef heap, void* value);
	void CFBinaryHeapRemoveMinimumValue (CFBinaryHeapRef heap);
	void CFBinaryHeapRemoveAllValues (CFBinaryHeapRef heap);
}