/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFDateFormatter;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDate;
import dstep.corefoundation.CFLocale;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

struct __CFDateFormatter;
alias __CFDateFormatter* CFDateFormatterRef;
alias int CFDateFormatterStyle;

extern (C)
{
	extern
	{
		const CFStringRef kCFDateFormatterIsLenient;
		const CFStringRef kCFDateFormatterTimeZone;
		const CFStringRef kCFDateFormatterCalendarName;
		const CFStringRef kCFDateFormatterDefaultFormat;
		const CFStringRef kCFDateFormatterTwoDigitStartDate;
		const CFStringRef kCFDateFormatterDefaultDate;
		const CFStringRef kCFDateFormatterCalendar;
		const CFStringRef kCFDateFormatterEraSymbols;
		const CFStringRef kCFDateFormatterMonthSymbols;
		const CFStringRef kCFDateFormatterShortMonthSymbols;
		const CFStringRef kCFDateFormatterWeekdaySymbols;
		const CFStringRef kCFDateFormatterShortWeekdaySymbols;
		const CFStringRef kCFDateFormatterAMSymbol;
		const CFStringRef kCFDateFormatterPMSymbol;
		const CFStringRef kCFDateFormatterLongEraSymbols;
		const CFStringRef kCFDateFormatterVeryShortMonthSymbols;
		const CFStringRef kCFDateFormatterStandaloneMonthSymbols;
		const CFStringRef kCFDateFormatterShortStandaloneMonthSymbols;
		const CFStringRef kCFDateFormatterVeryShortStandaloneMonthSymbols;
		const CFStringRef kCFDateFormatterVeryShortWeekdaySymbols;
		const CFStringRef kCFDateFormatterStandaloneWeekdaySymbols;
		const CFStringRef kCFDateFormatterShortStandaloneWeekdaySymbols;
		const CFStringRef kCFDateFormatterVeryShortStandaloneWeekdaySymbols;
		const CFStringRef kCFDateFormatterQuarterSymbols;
		const CFStringRef kCFDateFormatterShortQuarterSymbols;
		const CFStringRef kCFDateFormatterStandaloneQuarterSymbols;
		const CFStringRef kCFDateFormatterShortStandaloneQuarterSymbols;
		const CFStringRef kCFDateFormatterGregorianStartDate;
	}
}

enum
{
	kCFDateFormatterNoStyle = 0,
	kCFDateFormatterShortStyle = 1,
	kCFDateFormatterMediumStyle = 2,
	kCFDateFormatterLongStyle = 3,
	kCFDateFormatterFullStyle = 4
}

extern (C)
{
	uint CFDateFormatterGetTypeID ();
	CFDateFormatterRef CFDateFormatterCreate (CFAllocatorRef allocator, CFLocaleRef locale, int dateStyle, int timeStyle);
	CFLocaleRef CFDateFormatterGetLocale (CFDateFormatterRef formatter);
	int CFDateFormatterGetDateStyle (CFDateFormatterRef formatter);
	int CFDateFormatterGetTimeStyle (CFDateFormatterRef formatter);
	CFStringRef CFDateFormatterGetFormat (CFDateFormatterRef formatter);
	void CFDateFormatterSetFormat (CFDateFormatterRef formatter, CFStringRef formatString);
	CFStringRef CFDateFormatterCreateStringWithDate (CFAllocatorRef allocator, CFDateFormatterRef formatter, CFDateRef date);
	CFStringRef CFDateFormatterCreateStringWithAbsoluteTime (CFAllocatorRef allocator, CFDateFormatterRef formatter, double at);
	CFDateRef CFDateFormatterCreateDateFromString (CFAllocatorRef allocator, CFDateFormatterRef formatter, CFStringRef string, CFRange* rangep);
	ubyte CFDateFormatterGetAbsoluteTimeFromString (CFDateFormatterRef formatter, CFStringRef string, CFRange* rangep, double* atp);
	void CFDateFormatterSetProperty (CFDateFormatterRef formatter, CFStringRef key, void* value);
	void* CFDateFormatterCopyProperty (CFDateFormatterRef formatter, CFStringRef key);
}